<template>
  <h1>App.vue</h1>
  has {{parentData}} and can edit:<br>
   <input type="number" v-model="parentData.counter">
   <input type="text" v-model="parentData.user">
  <Component1 msg="This is Component1" :inputData="parentData" @updateData="updateData" />
  <Component2 :inputData="parentData" />
</template>

<script>
import Component1 from './components/Component1.vue'
import Component2 from './components/Component2.vue'

export default {
  name: 'App',
  data(){
    let parentData = { // this is the stuff for global usage. Annoying: its not in main.js
      user: "Jonny Doe",
      counter: 0
    }
    return {parentData:parentData}
  },
  methods:{
    updateData:function(newData){
      console.log("got updateData event:",newData);
      
      Object.assign(this.parentData,newData);
    }
  },
  components: {
    Component1:Component1,
    Component2:Component2,
  }
}
</script>

<style>
#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 60px;
}
</style>
